<?php
if (isset($_REQUEST['skrillModulId'])) {
    include_once('../../../../../../includes/globalinclude.php');
    include_once(PFAD_ROOT . PFAD_CLASSES . 'class.JTL-Shop.Bestellung.php');
    include_once(PFAD_ROOT . PFAD_INCLUDES . 'sprachfunktionen.php');
    include_once(PFAD_ROOT . PFAD_INCLUDES . 'mailTools.php');
    include_once(PFAD_ROOT . PFAD_INCLUDES_MODULES . 'PaymentMethod.class.php');

    $paymentMethod = PaymentMethod::create($_REQUEST['skrillModulId']);

    Jtllog::writeLog('Skrill refund status url response : ' . print_r($_REQUEST, true), JTLLOG_LEVEL_NOTICE);
    $paymentResult = array();
    foreach ($_REQUEST as $parameter => $value) {
        $parameter = strtolower($parameter);
        $paymentResult[$parameter] = $value;
    }

    $result = Shop::DB()->select('xplugin_jtl_skrill_orders', 'order_id', $paymentResult['orderId']);
    $paymenStatus = unserialize($result->payment_status);
    if (!$result) {
        Jtllog::writeLog(
            'Skrill refund status url order id not found : '.$paymentResult['orderId'],
            JTLLOG_LEVEL_ERROR
        );
        exit;
    } elseif (isset($paymentResult['orderId']) && $paymentResult['transactionKey'] == $paymenStatus['md5sig']) {
        if ($paymentResult['status'] == $paymentMethod::PROCESSED_STATUS) {
            $orderStatusId = $paymentMethod::REFUND_STATUS;
            $orderStatusName = $paymentMethod->getTranslateForceGER(
                $paymentMethod->getTransactionStatusIdentifier($orderStatusId)
            );
            $order = new stdClass();
            $order->status  = $orderStatusName;
            Shop::DB()->update('xplugin_jtl_skrill_orders', 'order_id', intval($paymentResult['orderId']), $order);
            
            $paymentMethod->updateOrderStatus($paymentResult['orderId'], $orderStatusId);
            Jtllog::writeLog(
                'Skrill refund status url refund success: (order_id = '.$paymentResult['orderId'].')',
                JTLLOG_LEVEL_NOTICE
            );
        } elseif ($paymentResult['status'] == $paymentMethod::FAILED_STATUS) {
            $orderStatusId = $paymentMethod::REFUND_FAILED_STATUS;
            $orderStatusName = $paymentMethod->getTranslateForceGER(
                $paymentMethod->getTransactionStatusIdentifier($orderStatusId)
            );
            $order = new stdClass();
            $order->status  = $orderStatusName;
            Shop::DB()->update('xplugin_jtl_skrill_orders', 'order_id', intval($paymentResult['orderId']), $order);
            
            Jtllog::writeLog(
                'Skrill refund status url refund failed: (order_id = '.$paymentResult['orderId'].')',
                JTLLOG_LEVEL_ERROR
            );
        } elseif ($paymentResult['status'] == $paymentMethod::PENDING_STATUS) {
            $orderStatusId = $paymentMethod::REFUND_PENDING_STATUS;
            $orderStatusName = $paymentMethod->getTranslateForceGER(
                $paymentMethod->getTransactionStatusIdentifier($orderStatusId)
            );
            $order = new stdClass();
            $order->status  = $orderStatusName;
            Shop::DB()->update('xplugin_jtl_skrill_orders', 'order_id', intval($paymentResult['orderId']), $order);

            Jtllog::writeLog(
                'Skrill refund status url refund pending: (order_id = '.$paymentResult['orderId'].')',
                JTLLOG_LEVEL_ERROR
            );
        }
    } else {
        Jtllog::writeLog(
            'unauthorized access from   : '.$_SERVER['REMOTE_ADDR'],
            JTLLOG_LEVEL_ERROR
        );

        exit();
    }
}
